/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 31 "policy_parse.y"

#include <sys/types.h>
#include <assert.h>
#include <stdarg.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include <sepol/policydb/expand.h>
#include <sepol/policydb/policydb.h>
#include <sepol/policydb/services.h>
#include <sepol/policydb/conditional.h>
#include <sepol/policydb/flask.h>
#include <sepol/policydb/hierarchy.h>
#include <sepol/policydb/polcaps.h>
#include "queue.h"
#include "checkpolicy.h"
#include "module_compiler.h"
#include "policy_define.h"

extern policydb_t *policydbp;
extern unsigned int pass;

extern char yytext[];
extern int yylex(void);
extern int yywarn(char *msg);
extern int yyerror(char *msg);

typedef int (* require_func_t)();



/* Line 189 of yacc.c  */
#line 110 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     PATH = 258,
     CLONE = 259,
     COMMON = 260,
     CLASS = 261,
     CONSTRAIN = 262,
     VALIDATETRANS = 263,
     INHERITS = 264,
     SID = 265,
     ROLE = 266,
     ROLES = 267,
     TYPEALIAS = 268,
     TYPEATTRIBUTE = 269,
     TYPEBOUNDS = 270,
     TYPE = 271,
     TYPES = 272,
     ALIAS = 273,
     ATTRIBUTE = 274,
     BOOL = 275,
     IF = 276,
     ELSE = 277,
     TYPE_TRANSITION = 278,
     TYPE_MEMBER = 279,
     TYPE_CHANGE = 280,
     ROLE_TRANSITION = 281,
     RANGE_TRANSITION = 282,
     SENSITIVITY = 283,
     DOMINANCE = 284,
     DOM = 285,
     DOMBY = 286,
     INCOMP = 287,
     CATEGORY = 288,
     LEVEL = 289,
     RANGE = 290,
     MLSCONSTRAIN = 291,
     MLSVALIDATETRANS = 292,
     USER = 293,
     NEVERALLOW = 294,
     ALLOW = 295,
     AUDITALLOW = 296,
     AUDITDENY = 297,
     DONTAUDIT = 298,
     SOURCE = 299,
     TARGET = 300,
     SAMEUSER = 301,
     FSCON = 302,
     PORTCON = 303,
     NETIFCON = 304,
     NODECON = 305,
     PIRQCON = 306,
     IOMEMCON = 307,
     IOPORTCON = 308,
     PCIDEVICECON = 309,
     FSUSEXATTR = 310,
     FSUSETASK = 311,
     FSUSETRANS = 312,
     GENFSCON = 313,
     U1 = 314,
     U2 = 315,
     U3 = 316,
     R1 = 317,
     R2 = 318,
     R3 = 319,
     T1 = 320,
     T2 = 321,
     T3 = 322,
     L1 = 323,
     L2 = 324,
     H1 = 325,
     H2 = 326,
     NOT = 327,
     AND = 328,
     OR = 329,
     XOR = 330,
     CTRUE = 331,
     CFALSE = 332,
     IDENTIFIER = 333,
     NUMBER = 334,
     EQUALS = 335,
     NOTEQUAL = 336,
     IPV4_ADDR = 337,
     IPV6_ADDR = 338,
     MODULE = 339,
     VERSION_IDENTIFIER = 340,
     REQUIRE = 341,
     OPTIONAL = 342,
     POLICYCAP = 343,
     PERMISSIVE = 344,
     FILESYSTEM = 345
   };
#endif
/* Tokens.  */
#define PATH 258
#define CLONE 259
#define COMMON 260
#define CLASS 261
#define CONSTRAIN 262
#define VALIDATETRANS 263
#define INHERITS 264
#define SID 265
#define ROLE 266
#define ROLES 267
#define TYPEALIAS 268
#define TYPEATTRIBUTE 269
#define TYPEBOUNDS 270
#define TYPE 271
#define TYPES 272
#define ALIAS 273
#define ATTRIBUTE 274
#define BOOL 275
#define IF 276
#define ELSE 277
#define TYPE_TRANSITION 278
#define TYPE_MEMBER 279
#define TYPE_CHANGE 280
#define ROLE_TRANSITION 281
#define RANGE_TRANSITION 282
#define SENSITIVITY 283
#define DOMINANCE 284
#define DOM 285
#define DOMBY 286
#define INCOMP 287
#define CATEGORY 288
#define LEVEL 289
#define RANGE 290
#define MLSCONSTRAIN 291
#define MLSVALIDATETRANS 292
#define USER 293
#define NEVERALLOW 294
#define ALLOW 295
#define AUDITALLOW 296
#define AUDITDENY 297
#define DONTAUDIT 298
#define SOURCE 299
#define TARGET 300
#define SAMEUSER 301
#define FSCON 302
#define PORTCON 303
#define NETIFCON 304
#define NODECON 305
#define PIRQCON 306
#define IOMEMCON 307
#define IOPORTCON 308
#define PCIDEVICECON 309
#define FSUSEXATTR 310
#define FSUSETASK 311
#define FSUSETRANS 312
#define GENFSCON 313
#define U1 314
#define U2 315
#define U3 316
#define R1 317
#define R2 318
#define R3 319
#define T1 320
#define T2 321
#define T3 322
#define L1 323
#define L2 324
#define H1 325
#define H2 326
#define NOT 327
#define AND 328
#define OR 329
#define XOR 330
#define CTRUE 331
#define CFALSE 332
#define IDENTIFIER 333
#define NUMBER 334
#define EQUALS 335
#define NOTEQUAL 336
#define IPV4_ADDR 337
#define IPV6_ADDR 338
#define MODULE 339
#define VERSION_IDENTIFIER 340
#define REQUIRE 341
#define OPTIONAL 342
#define POLICYCAP 343
#define PERMISSIVE 344
#define FILESYSTEM 345




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 68 "policy_parse.y"

	unsigned int val;
	uintptr_t valptr;
	void *ptr;
        require_func_t require_func;



/* Line 214 of yacc.c  */
#line 335 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 347 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   885

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  101
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  168
/* YYNRULES -- Number of rules.  */
#define YYNRULES  334
/* YYNRULES -- Number of states.  */
#define YYNSTATES  662

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   345

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      96,    97,   100,     2,    95,    98,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    94,    93,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    91,     2,    92,    99,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     8,     9,    10,    27,    29,
      32,    35,    37,    40,    43,    46,    48,    49,    51,    54,
      60,    62,    65,    71,    76,    84,    86,    87,    93,    95,
      98,   103,   107,   110,   113,   118,   120,   121,   123,   126,
     131,   135,   137,   140,   146,   150,   152,   155,   157,   159,
     165,   170,   172,   175,   177,   179,   181,   183,   185,   187,
     189,   191,   193,   195,   197,   199,   201,   203,   205,   207,
     209,   211,   213,   215,   219,   225,   230,   235,   240,   245,
     248,   249,   254,   256,   258,   265,   270,   271,   275,   278,
     282,   286,   290,   294,   298,   300,   302,   305,   306,   308,
     310,   312,   320,   328,   336,   338,   340,   342,   344,   352,
     360,   368,   376,   384,   392,   400,   406,   414,   416,   418,
     420,   422,   424,   432,   440,   448,   456,   464,   470,   474,
     479,   485,   490,   492,   495,   499,   505,   507,   508,   510,
     513,   515,   517,   523,   528,   532,   535,   539,   543,   545,
     549,   553,   557,   558,   563,   564,   569,   570,   575,   576,
     581,   582,   587,   588,   593,   594,   599,   600,   605,   606,
     611,   613,   614,   619,   620,   625,   628,   629,   634,   635,
     640,   644,   648,   652,   656,   660,   664,   666,   668,   670,
     672,   674,   676,   678,   681,   688,   693,   694,   696,   699,
     703,   705,   706,   708,   711,   713,   715,   717,   719,   723,
     727,   733,   737,   743,   747,   749,   750,   752,   755,   761,
     765,   767,   768,   770,   773,   778,   785,   787,   788,   790,
     793,   798,   800,   801,   803,   806,   811,   816,   818,   819,
     821,   824,   829,   834,   839,   841,   842,   844,   847,   854,
     855,   863,   868,   870,   877,   880,   881,   885,   887,   891,
     893,   895,   899,   901,   903,   905,   907,   909,   912,   915,
     916,   921,   923,   925,   927,   931,   933,   936,   941,   943,
     946,   948,   950,   953,   957,   959,   962,   964,   965,   969,
     971,   973,   975,   977,   979,   981,   983,   987,   991,   994,
     999,  1001,  1003,  1005,  1008,  1011,  1013,  1015,  1017,  1019,
    1021,  1023,  1025,  1030,  1033,  1035,  1038,  1042,  1046,  1048,
    1050,  1052,  1054,  1056,  1058,  1060,  1062,  1066,  1067,  1074,
    1079,  1080,  1082,  1084,  1087
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     102,     0,    -1,   103,    -1,   251,    -1,    -1,    -1,    -1,
     104,   107,   109,   111,   105,   117,   132,   192,   170,   106,
     195,   204,   217,   220,   207,   197,    -1,   108,    -1,   107,
     108,    -1,     6,   244,    -1,   110,    -1,   109,   110,    -1,
      10,   244,    -1,   112,   115,    -1,   113,    -1,    -1,   114,
      -1,   113,   114,    -1,     5,   244,    91,   239,    92,    -1,
     116,    -1,   115,   116,    -1,     6,   244,    91,   239,    92,
      -1,     6,   244,     9,   244,    -1,     6,   244,     9,   244,
      91,   239,    92,    -1,   118,    -1,    -1,   119,   122,   123,
     126,   128,    -1,   120,    -1,   119,   120,    -1,    28,   244,
     121,    93,    -1,    28,   244,    93,    -1,    18,   232,    -1,
      29,   244,    -1,    29,    91,   239,    92,    -1,   124,    -1,
      -1,   125,    -1,   124,   125,    -1,    33,   244,   121,    93,
      -1,    33,   244,    93,    -1,   127,    -1,   126,   127,    -1,
      34,   244,    94,   229,    93,    -1,    34,   244,    93,    -1,
     129,    -1,   128,   129,    -1,   130,    -1,   131,    -1,    36,
     232,   232,   175,    93,    -1,    37,   232,   175,    93,    -1,
     133,    -1,   132,   133,    -1,   135,    -1,   134,    -1,   144,
      -1,   263,    -1,   249,    -1,    93,    -1,   164,    -1,   165,
      -1,   166,    -1,   167,    -1,   136,    -1,   137,    -1,   138,
      -1,   139,    -1,   140,    -1,   142,    -1,   156,    -1,   157,
      -1,   158,    -1,   250,    -1,    19,   244,    93,    -1,    16,
     244,   121,   141,    93,    -1,    16,   244,   141,    93,    -1,
      13,   244,   121,    93,    -1,    14,   244,   229,    93,    -1,
      15,   244,   229,    93,    -1,    95,   229,    -1,    -1,    20,
     244,   143,    93,    -1,    76,    -1,    77,    -1,    21,   146,
      91,   148,    92,   145,    -1,    22,    91,   148,    92,    -1,
      -1,    96,   146,    97,    -1,    72,   146,    -1,   146,    73,
     146,    -1,   146,    74,   146,    -1,   146,    75,   146,    -1,
     146,    80,   146,    -1,   146,    81,   146,    -1,   147,    -1,
     244,    -1,   148,   149,    -1,    -1,   150,    -1,   151,    -1,
     257,    -1,    23,   232,   232,    94,   232,   244,    93,    -1,
      24,   232,   232,    94,   232,   244,    93,    -1,    25,   232,
     232,    94,   232,   244,    93,    -1,   152,    -1,   153,    -1,
     154,    -1,   155,    -1,    40,   232,   232,    94,   232,   232,
      93,    -1,    41,   232,   232,    94,   232,   232,    93,    -1,
      42,   232,   232,    94,   232,   232,    93,    -1,    43,   232,
     232,    94,   232,   232,    93,    -1,    23,   232,   232,    94,
     232,   244,    93,    -1,    24,   232,   232,    94,   232,   244,
      93,    -1,    25,   232,   232,    94,   232,   244,    93,    -1,
      27,   232,   232,   227,    93,    -1,    27,   232,   232,    94,
     232,   227,    93,    -1,   159,    -1,   160,    -1,   161,    -1,
     162,    -1,   163,    -1,    40,   232,   232,    94,   232,   232,
      93,    -1,    41,   232,   232,    94,   232,   232,    93,    -1,
      42,   232,   232,    94,   232,   232,    93,    -1,    43,   232,
     232,    94,   232,   232,    93,    -1,    39,   232,   232,    94,
     232,   232,    93,    -1,    11,   244,    17,   232,    93,    -1,
      11,   244,    93,    -1,    29,    91,   168,    92,    -1,    26,
     232,   232,   244,    93,    -1,    40,   232,   232,    93,    -1,
     169,    -1,   168,   169,    -1,    11,   238,    93,    -1,    11,
     238,    91,   168,    92,    -1,   171,    -1,    -1,   172,    -1,
     171,   172,    -1,   173,    -1,   174,    -1,     7,   232,   232,
     175,    93,    -1,     8,   232,   175,    93,    -1,    96,   175,
      97,    -1,    72,   175,    -1,   175,    73,   175,    -1,   175,
      74,   175,    -1,   176,    -1,    59,   190,    60,    -1,    62,
     191,    63,    -1,    65,   190,    66,    -1,    -1,    59,   190,
     177,   236,    -1,    -1,    60,   190,   178,   236,    -1,    -1,
      61,   190,   179,   236,    -1,    -1,    62,   190,   180,   236,
      -1,    -1,    63,   190,   181,   236,    -1,    -1,    64,   190,
     182,   236,    -1,    -1,    65,   190,   183,   236,    -1,    -1,
      66,   190,   184,   236,    -1,    -1,    67,   190,   185,   236,
      -1,    46,    -1,    -1,    44,    11,   186,   236,    -1,    -1,
      45,    11,   187,   236,    -1,    11,   191,    -1,    -1,    44,
      16,   188,   236,    -1,    -1,    45,    16,   189,   236,    -1,
      68,   191,    69,    -1,    68,   191,    71,    -1,    70,   191,
      69,    -1,    70,   191,    71,    -1,    68,   191,    70,    -1,
      69,   191,    71,    -1,    80,    -1,    81,    -1,   190,    -1,
      30,    -1,    31,    -1,    32,    -1,   193,    -1,   192,   193,
      -1,    38,   244,    12,   232,   194,    93,    -1,    34,   228,
      35,   227,    -1,    -1,   196,    -1,   195,   196,    -1,    10,
     244,   225,    -1,   198,    -1,    -1,   199,    -1,   198,   199,
      -1,   200,    -1,   201,    -1,   202,    -1,   203,    -1,    51,
     247,   225,    -1,    52,   247,   225,    -1,    52,   247,    98,
     247,   225,    -1,    53,   247,   225,    -1,    53,   247,    98,
     247,   225,    -1,    54,   247,   225,    -1,   205,    -1,    -1,
     206,    -1,   205,   206,    -1,    47,   247,   247,   225,   225,
      -1,   208,   211,   214,    -1,   209,    -1,    -1,   210,    -1,
     209,   210,    -1,    48,   244,   247,   225,    -1,    48,   244,
     247,    98,   247,   225,    -1,   212,    -1,    -1,   213,    -1,
     212,   213,    -1,    49,   244,   225,   225,    -1,   215,    -1,
      -1,   216,    -1,   215,   216,    -1,    50,   224,   224,   225,
      -1,    50,   248,   248,   225,    -1,   218,    -1,    -1,   219,
      -1,   218,   219,    -1,    55,   245,   225,    93,    -1,    56,
     244,   225,    93,    -1,    57,   244,   225,    93,    -1,   221,
      -1,    -1,   222,    -1,   221,   222,    -1,    58,   245,   246,
      98,   244,   225,    -1,    -1,    58,   245,   246,    98,    98,
     223,   225,    -1,    58,   245,   246,   225,    -1,    82,    -1,
     244,    94,   244,    94,   244,   226,    -1,    94,   227,    -1,
      -1,   228,    98,   228,    -1,   228,    -1,   244,    94,   229,
      -1,   244,    -1,   244,    -1,   229,    95,   244,    -1,    99,
      -1,   100,    -1,   244,    -1,   240,    -1,   231,    -1,   230,
     244,    -1,   230,   240,    -1,    -1,   244,    98,   233,   244,
      -1,   230,    -1,   231,    -1,   238,    -1,    91,   237,    92,
      -1,   235,    -1,   234,   238,    -1,   234,    91,   237,    92,
      -1,   238,    -1,   237,   238,    -1,    78,    -1,   244,    -1,
     239,   244,    -1,    91,   241,    92,    -1,   242,    -1,   241,
     242,    -1,   244,    -1,    -1,    98,   243,   244,    -1,   240,
      -1,    78,    -1,    90,    -1,    78,    -1,     3,    -1,    79,
      -1,    83,    -1,    88,   244,    93,    -1,    89,   244,    93,
      -1,   252,   254,    -1,    84,   244,   253,    93,    -1,    85,
      -1,   247,    -1,   224,    -1,   255,   268,    -1,   255,   256,
      -1,   256,    -1,   134,    -1,   135,    -1,   144,    -1,   257,
      -1,   263,    -1,    93,    -1,    86,    91,   258,    92,    -1,
     258,   259,    -1,   259,    -1,   260,    93,    -1,   261,   262,
      93,    -1,     6,   244,   232,    -1,    11,    -1,    16,    -1,
      19,    -1,    38,    -1,    20,    -1,    28,    -1,    33,    -1,
     244,    -1,   262,    95,   244,    -1,    -1,   266,    91,   254,
      92,   264,   265,    -1,   267,    91,   254,    92,    -1,    -1,
      87,    -1,    22,    -1,   193,   268,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   149,   149,   150,   152,   154,   157,   152,   161,   162,
     164,   167,   168,   170,   173,   175,   176,   178,   179,   181,
     184,   185,   187,   189,   191,   194,   195,   197,   199,   200,
     202,   204,   207,   209,   211,   214,   215,   217,   218,   220,
     222,   225,   226,   228,   230,   233,   234,   236,   237,   239,
     242,   245,   246,   248,   249,   250,   251,   252,   253,   255,
     256,   257,   258,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   271,   274,   276,   279,   282,   285,   288,
     289,   291,   294,   296,   299,   302,   305,   306,   308,   311,
     314,   317,   320,   323,   326,   329,   333,   336,   338,   340,
     342,   345,   348,   351,   355,   357,   359,   361,   364,   368,
     372,   376,   380,   382,   384,   387,   389,   392,   393,   394,
     395,   396,   398,   401,   404,   407,   410,   413,   415,   418,
     420,   423,   426,   428,   431,   433,   436,   437,   439,   440,
     442,   443,   445,   448,   451,   453,   456,   459,   462,   465,
     468,   471,   474,   474,   477,   477,   480,   480,   483,   483,
     486,   486,   489,   489,   492,   492,   495,   495,   498,   498,
     501,   504,   504,   507,   507,   510,   513,   513,   516,   516,
     519,   522,   525,   528,   531,   534,   538,   540,   543,   545,
     547,   549,   552,   553,   555,   558,   559,   561,   562,   564,
     567,   567,   569,   570,   572,   573,   574,   575,   577,   580,
     582,   585,   587,   590,   593,   594,   596,   597,   599,   602,
     604,   605,   607,   608,   610,   612,   615,   616,   618,   619,
     621,   624,   625,   627,   628,   630,   632,   635,   636,   638,
     639,   641,   643,   645,   648,   649,   651,   652,   654,   656,
     656,   658,   661,   664,   666,   667,   669,   671,   674,   676,
     679,   680,   682,   684,   686,   688,   690,   693,   696,   699,
     699,   702,   705,   708,   709,   710,   711,   712,   714,   715,
     717,   720,   721,   723,   725,   725,   727,   727,   727,   727,
     729,   732,   734,   737,   740,   743,   746,   749,   754,   759,
     762,   764,   766,   768,   770,   771,   773,   774,   775,   776,
     777,   778,   780,   782,   783,   785,   786,   788,   791,   792,
     793,   794,   795,   796,   797,   799,   801,   805,   804,   809,
     811,   813,   816,   819,   820
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PATH", "CLONE", "COMMON", "CLASS",
  "CONSTRAIN", "VALIDATETRANS", "INHERITS", "SID", "ROLE", "ROLES",
  "TYPEALIAS", "TYPEATTRIBUTE", "TYPEBOUNDS", "TYPE", "TYPES", "ALIAS",
  "ATTRIBUTE", "BOOL", "IF", "ELSE", "TYPE_TRANSITION", "TYPE_MEMBER",
  "TYPE_CHANGE", "ROLE_TRANSITION", "RANGE_TRANSITION", "SENSITIVITY",
  "DOMINANCE", "DOM", "DOMBY", "INCOMP", "CATEGORY", "LEVEL", "RANGE",
  "MLSCONSTRAIN", "MLSVALIDATETRANS", "USER", "NEVERALLOW", "ALLOW",
  "AUDITALLOW", "AUDITDENY", "DONTAUDIT", "SOURCE", "TARGET", "SAMEUSER",
  "FSCON", "PORTCON", "NETIFCON", "NODECON", "PIRQCON", "IOMEMCON",
  "IOPORTCON", "PCIDEVICECON", "FSUSEXATTR", "FSUSETASK", "FSUSETRANS",
  "GENFSCON", "U1", "U2", "U3", "R1", "R2", "R3", "T1", "T2", "T3", "L1",
  "L2", "H1", "H2", "NOT", "AND", "OR", "XOR", "CTRUE", "CFALSE",
  "IDENTIFIER", "NUMBER", "EQUALS", "NOTEQUAL", "IPV4_ADDR", "IPV6_ADDR",
  "MODULE", "VERSION_IDENTIFIER", "REQUIRE", "OPTIONAL", "POLICYCAP",
  "PERMISSIVE", "FILESYSTEM", "'{'", "'}'", "';'", "':'", "','", "'('",
  "')'", "'-'", "'~'", "'*'", "$accept", "policy", "base_policy", "$@1",
  "$@2", "$@3", "classes", "class_def", "initial_sids", "initial_sid_def",
  "access_vectors", "opt_common_perms", "common_perms", "common_perms_def",
  "av_perms", "av_perms_def", "opt_mls", "mls", "sensitivities",
  "sensitivity_def", "alias_def", "dominance", "opt_categories",
  "categories", "category_def", "levels", "level_def", "mlspolicy",
  "mlspolicy_decl", "mlsconstraint_def", "mlsvalidatetrans_def", "te_rbac",
  "te_rbac_decl", "rbac_decl", "te_decl", "attribute_def", "type_def",
  "typealias_def", "typeattribute_def", "typebounds_def", "opt_attr_list",
  "bool_def", "bool_val", "cond_stmt_def", "cond_else", "cond_expr",
  "cond_expr_prim", "cond_pol_list", "cond_rule_def",
  "cond_transition_def", "cond_te_avtab_def", "cond_allow_def",
  "cond_auditallow_def", "cond_auditdeny_def", "cond_dontaudit_def",
  "transition_def", "range_trans_def", "te_avtab_def", "allow_def",
  "auditallow_def", "auditdeny_def", "dontaudit_def", "neverallow_def",
  "role_type_def", "role_dominance", "role_trans_def", "role_allow_def",
  "roles", "role_def", "opt_constraints", "constraints", "constraint_decl",
  "constraint_def", "validatetrans_def", "cexpr", "cexpr_prim", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13",
  "$@14", "$@15", "$@16", "op", "role_mls_op", "users", "user_def",
  "opt_mls_user", "initial_sid_contexts", "initial_sid_context_def",
  "opt_dev_contexts", "dev_contexts", "dev_context_def",
  "pirq_context_def", "iomem_context_def", "ioport_context_def",
  "pci_context_def", "opt_fs_contexts", "fs_contexts", "fs_context_def",
  "net_contexts", "opt_port_contexts", "port_contexts", "port_context_def",
  "opt_netif_contexts", "netif_contexts", "netif_context_def",
  "opt_node_contexts", "node_contexts", "node_context_def", "opt_fs_uses",
  "fs_uses", "fs_use_def", "opt_genfs_contexts", "genfs_contexts",
  "genfs_context_def", "$@17", "ipv4_addr_def", "security_context_def",
  "opt_mls_range_def", "mls_range_def", "mls_level_def", "id_comma_list",
  "tilde", "asterisk", "names", "$@18", "tilde_push", "asterisk_push",
  "names_push", "identifier_list_push", "identifier_push",
  "identifier_list", "nested_id_set", "nested_id_list",
  "nested_id_element", "$@19", "identifier", "filesystem", "path",
  "number", "ipv6_addr", "policycap_def", "permissive_def",
  "module_policy", "module_def", "version_identifier", "avrules_block",
  "avrule_decls", "avrule_decl", "require_block", "require_list",
  "require_decl", "require_class", "require_decl_def", "require_id_list",
  "optional_block", "$@20", "optional_else", "optional_decl", "else_decl",
  "avrule_user_defs", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   123,   125,    59,    58,    44,    40,    41,    45,   126,
      42
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   101,   102,   102,   104,   105,   106,   103,   107,   107,
     108,   109,   109,   110,   111,   112,   112,   113,   113,   114,
     115,   115,   116,   116,   116,   117,   117,   118,   119,   119,
     120,   120,   121,   122,   122,   123,   123,   124,   124,   125,
     125,   126,   126,   127,   127,   128,   128,   129,   129,   130,
     131,   132,   132,   133,   133,   133,   133,   133,   133,   134,
     134,   134,   134,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   136,   137,   137,   138,   139,   140,   141,
     141,   142,   143,   143,   144,   145,   145,   146,   146,   146,
     146,   146,   146,   146,   146,   147,   148,   148,   149,   149,
     149,   150,   150,   150,   151,   151,   151,   151,   152,   153,
     154,   155,   156,   156,   156,   157,   157,   158,   158,   158,
     158,   158,   159,   160,   161,   162,   163,   164,   164,   165,
     166,   167,   168,   168,   169,   169,   170,   170,   171,   171,
     172,   172,   173,   174,   175,   175,   175,   175,   175,   176,
     176,   176,   177,   176,   178,   176,   179,   176,   180,   176,
     181,   176,   182,   176,   183,   176,   184,   176,   185,   176,
     176,   186,   176,   187,   176,   176,   188,   176,   189,   176,
     176,   176,   176,   176,   176,   176,   190,   190,   191,   191,
     191,   191,   192,   192,   193,   194,   194,   195,   195,   196,
     197,   197,   198,   198,   199,   199,   199,   199,   200,   201,
     201,   202,   202,   203,   204,   204,   205,   205,   206,   207,
     208,   208,   209,   209,   210,   210,   211,   211,   212,   212,
     213,   214,   214,   215,   215,   216,   216,   217,   217,   218,
     218,   219,   219,   219,   220,   220,   221,   221,   222,   223,
     222,   222,   224,   225,   226,   226,   227,   227,   228,   228,
     229,   229,   230,   231,   232,   232,   232,   232,   232,   233,
     232,   234,   235,   236,   236,   236,   236,   236,   237,   237,
     238,   239,   239,   240,   241,   241,   242,   243,   242,   242,
     244,   245,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   253,   253,   254,   255,   255,   256,   256,   256,   256,
     256,   256,   257,   258,   258,   259,   259,   260,   261,   261,
     261,   261,   261,   261,   261,   262,   262,   264,   263,   265,
     265,   266,   267,   268,   268
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     0,     0,     0,    16,     1,     2,
       2,     1,     2,     2,     2,     1,     0,     1,     2,     5,
       1,     2,     5,     4,     7,     1,     0,     5,     1,     2,
       4,     3,     2,     2,     4,     1,     0,     1,     2,     4,
       3,     1,     2,     5,     3,     1,     2,     1,     1,     5,
       4,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     5,     4,     4,     4,     4,     2,
       0,     4,     1,     1,     6,     4,     0,     3,     2,     3,
       3,     3,     3,     3,     1,     1,     2,     0,     1,     1,
       1,     7,     7,     7,     1,     1,     1,     1,     7,     7,
       7,     7,     7,     7,     7,     5,     7,     1,     1,     1,
       1,     1,     7,     7,     7,     7,     7,     5,     3,     4,
       5,     4,     1,     2,     3,     5,     1,     0,     1,     2,
       1,     1,     5,     4,     3,     2,     3,     3,     1,     3,
       3,     3,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       1,     0,     4,     0,     4,     2,     0,     4,     0,     4,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     2,     6,     4,     0,     1,     2,     3,
       1,     0,     1,     2,     1,     1,     1,     1,     3,     3,
       5,     3,     5,     3,     1,     0,     1,     2,     5,     3,
       1,     0,     1,     2,     4,     6,     1,     0,     1,     2,
       4,     1,     0,     1,     2,     4,     4,     1,     0,     1,
       2,     4,     4,     4,     1,     0,     1,     2,     6,     0,
       7,     4,     1,     6,     2,     0,     3,     1,     3,     1,
       1,     3,     1,     1,     1,     1,     1,     2,     2,     0,
       4,     1,     1,     1,     3,     1,     2,     4,     1,     2,
       1,     1,     2,     3,     1,     2,     1,     0,     3,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     2,     4,
       1,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     4,     2,     1,     2,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     0,     6,     4,
       0,     1,     1,     2,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     2,     0,     3,     0,   290,     0,     1,
       0,     0,     8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   331,     0,   311,   306,   307,    63,    64,
      65,    66,    67,    68,   308,    69,    70,    71,   117,   118,
     119,   120,   121,    59,    60,    61,    62,    72,   298,   334,
     305,   309,   310,     0,   294,   252,   300,   302,   301,     0,
      10,     0,     9,    16,    11,     0,     0,     0,     0,    80,
       0,     0,     0,     0,     0,    94,    95,     0,   262,   263,
       0,   266,     0,   265,   264,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   334,   304,
     303,     0,   299,    13,     0,    12,     5,     0,    15,    17,
       0,   128,     0,     0,     0,   260,     0,     0,    80,     0,
      73,    82,    83,     0,    88,     0,     0,     0,     0,     0,
       0,    97,   287,   289,     0,   284,   286,   268,   267,     0,
     269,     0,     0,     0,     0,     0,     0,   132,     0,     0,
       0,     0,     0,     0,   318,   319,   320,   322,   323,   324,
     321,     0,   314,     0,     0,   297,     0,   333,     0,     0,
      26,     0,    14,    20,    18,     0,    32,    76,    77,     0,
      78,    79,     0,    75,    81,    87,    89,    90,    91,    92,
      93,     0,     0,   283,   285,     0,     0,     0,     0,     0,
       0,     0,   257,   259,   280,     0,   129,   133,     0,   131,
       0,     0,     0,     0,     0,   312,   313,   315,   325,     0,
       0,   327,     0,     0,     0,    25,     0,    28,     0,    21,
     127,   261,    74,     0,     0,     0,     0,     0,     0,     0,
      86,    96,    98,    99,   104,   105,   106,   107,   100,   288,
       0,   270,     0,     0,   130,     0,   115,     0,     0,     0,
     134,     0,     0,     0,     0,     0,   317,   316,     0,   196,
     330,     0,   281,     0,     0,    58,     0,    51,    54,    53,
      55,    57,    56,     0,    29,    36,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    84,     0,     0,     0,
       0,   256,   258,     0,     0,     0,     0,     0,     0,   326,
       0,     0,   332,   328,     0,    19,   282,    31,     0,     0,
      52,   137,   192,     0,    33,     0,     0,    35,    37,    23,
       0,     0,     0,     0,     0,     0,     0,     0,    97,   112,
     113,   114,   116,   135,   126,   122,   123,   124,   125,     0,
     194,     0,    30,   296,     0,     0,     6,   136,   138,   140,
     141,   193,     0,     0,     0,     0,    41,    38,     0,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   139,    34,    40,     0,     0,     0,     0,
      42,    27,    45,    47,    48,     0,     0,     0,     0,     0,
       0,     0,     0,    85,   195,   329,     0,     0,     0,     0,
     170,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   148,     0,   215,   197,
      39,    44,     0,     0,     0,    46,    24,     0,     0,     0,
       0,     0,     0,     0,     0,   189,   190,   191,   186,   187,
     188,   175,   171,   176,   173,   178,   152,   154,   156,   158,
       0,   160,   162,   164,   166,   168,     0,     0,     0,   145,
       0,     0,     0,   143,     0,     0,   198,   238,   214,   216,
       0,     0,     0,   101,   102,   103,   108,   109,   110,   111,
     142,     0,     0,     0,     0,   149,     0,     0,     0,     0,
     150,     0,     0,   151,     0,     0,     0,   180,   184,   181,
     185,   182,   183,   144,   146,   147,   199,     0,     0,     0,
       0,     0,   245,   237,   239,   217,    43,     0,    50,     0,
     271,   272,     0,   275,   172,   273,   177,   174,   179,   153,
     155,   157,   159,   161,   163,   165,   167,   169,     0,     0,
     292,   291,     0,     0,     0,     0,   221,   244,   246,   240,
      49,     0,   278,     0,   276,     0,     0,     0,     0,     0,
       0,     0,   201,   227,   220,   222,   247,   274,   279,     0,
       0,   218,   241,   242,   243,   293,     0,     0,     0,     0,
       0,     0,     7,   200,   202,   204,   205,   206,   207,     0,
     232,   226,   228,   223,   277,   255,     0,   251,     0,     0,
       0,     0,     0,   203,     0,     0,   219,   231,   233,   229,
       0,   253,   249,     0,     0,   224,   208,     0,   209,     0,
     211,   213,     0,   295,     0,     0,   234,   254,     0,   248,
       0,     0,     0,   230,     0,     0,   250,   225,   210,   212,
     235,   236
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,   180,   392,    11,    12,    73,    74,
     116,   117,   118,   119,   182,   183,   234,   235,   236,   237,
     123,   295,   336,   337,   338,   375,   376,   401,   402,   403,
     404,   286,   287,    36,    37,    38,    39,    40,    41,    42,
     129,    43,   133,    44,   306,    84,    85,   201,   251,   252,
     253,   254,   255,   256,   257,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,   156,   157,   366,
     367,   368,   369,   370,   435,   436,   506,   507,   508,   509,
     511,   512,   514,   515,   516,   501,   503,   502,   504,   460,
     461,   331,   108,   321,   438,   439,   602,   603,   604,   605,
     606,   607,   608,   487,   488,   489,   582,   583,   584,   585,
     610,   611,   612,   626,   627,   628,   532,   533,   534,   566,
     567,   568,   648,    67,   526,   631,   211,   212,   124,    90,
      91,    92,   206,   542,   543,   544,   571,   545,   281,    93,
     144,   145,   202,    94,   562,   596,    68,   645,   291,    57,
       5,     6,    69,    58,    59,    60,    61,   171,   172,   173,
     174,   229,    62,   280,   323,    63,   324,   110
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -517
static const yytype_int16 yypact[] =
{
     -57,   -11,   172,  -517,   170,  -517,   737,  -517,   175,  -517,
     -11,    55,  -517,   -11,   -11,   -11,   -11,   -11,   -11,   -11,
     -28,   109,   109,   109,   109,   109,    87,   109,   109,   109,
     109,   109,   115,  -517,   -11,  -517,  -517,  -517,  -517,  -517,
    -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,
    -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,   438,
    -517,  -517,  -517,   142,  -517,  -517,  -517,  -517,  -517,    89,
    -517,   -11,  -517,   253,  -517,    -6,   247,   -11,   -11,   -10,
     163,    53,   -28,   -28,   198,  -517,  -517,   -29,  -517,  -517,
      21,  -517,   109,  -517,   171,   109,   109,   109,   109,   276,
     109,   109,   109,   109,   109,   324,   205,   -11,   256,  -517,
    -517,   737,  -517,  -517,   -11,  -517,  -517,   318,   337,  -517,
     109,  -517,   109,   272,   100,  -517,   238,   -11,   274,   282,
    -517,  -517,  -517,   287,   210,   123,   -28,   -28,   -28,   -28,
     -28,  -517,  -517,  -517,   143,  -517,  -517,  -517,  -517,   289,
    -517,   290,   292,   -11,    85,   319,     9,  -517,   295,   224,
     327,   328,   329,   -11,  -517,  -517,  -517,  -517,  -517,  -517,
    -517,    18,  -517,   310,   -11,  -517,   412,  -517,   333,   336,
     398,   -11,   318,  -517,  -517,   339,  -517,  -517,  -517,   -11,
    -517,   334,   340,  -517,  -517,  -517,   210,   195,   201,  -517,
    -517,    91,   -11,  -517,  -517,   109,   -11,   109,   109,   341,
     109,   344,   330,   345,  -517,   270,  -517,  -517,   109,  -517,
     109,   109,   109,   109,   109,  -517,  -517,  -517,  -517,   271,
     109,  -517,   -11,   -11,   792,  -517,   309,  -517,     1,  -517,
    -517,  -517,  -517,   109,   109,   109,   109,   109,   109,   109,
     408,  -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,
     -11,  -517,   -11,   -11,  -517,   -11,  -517,   -11,   -11,   276,
    -517,   109,   109,   109,   109,   109,  -517,  -517,   -11,   397,
     416,   -38,  -517,     5,   -11,  -517,   704,  -517,  -517,  -517,
    -517,  -517,  -517,    33,  -517,   407,   -11,   -11,   109,   109,
     109,   109,   109,   109,   109,   351,  -517,   352,   353,   354,
     355,  -517,   334,    11,   357,   362,   363,   367,   373,  -517,
     -11,   375,  -517,  -517,   378,  -517,  -517,  -517,   377,   379,
    -517,    52,  -517,   -11,  -517,   -11,   409,   407,  -517,   380,
     -26,   381,   388,   394,   399,   402,   406,   410,  -517,  -517,
    -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,   439,
    -517,   737,  -517,  -517,   109,   109,  -517,   338,  -517,  -517,
    -517,  -517,   107,     7,   -11,   193,  -517,  -517,   -11,  -517,
     109,   109,   109,   109,   109,   109,   109,   126,   -11,   415,
     109,   240,   434,  -517,  -517,  -517,   417,   257,   109,   109,
    -517,   342,  -517,  -517,  -517,   148,   -11,   -11,   -11,   109,
     109,   109,   109,  -517,  -517,  -517,   240,    42,   277,   300,
    -517,   311,   311,   311,    42,   311,   311,   311,   311,   311,
      42,    42,    42,   240,   240,    34,  -517,   -11,    31,  -517,
    -517,  -517,   -11,   109,   240,  -517,  -517,   418,   419,   420,
     421,   422,   424,   430,    82,  -517,  -517,  -517,  -517,  -517,
    -517,  -517,  -517,  -517,  -517,  -517,   413,  -517,  -517,   446,
     463,  -517,  -517,   435,  -517,  -517,   244,   431,   301,  -517,
      68,   240,   240,  -517,   -11,   453,  -517,   303,   486,  -517,
     281,   240,   149,  -517,  -517,  -517,  -517,  -517,  -517,  -517,
    -517,   111,   111,   111,   111,  -517,   111,   111,   111,   111,
    -517,   111,   111,  -517,   111,   111,   111,  -517,  -517,  -517,
    -517,  -517,  -517,  -517,  -517,   461,  -517,   441,   453,   158,
     -11,   -11,   478,   303,  -517,  -517,  -517,   151,  -517,   319,
    -517,  -517,    83,  -517,  -517,  -517,  -517,  -517,  -517,  -517,
    -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,   -11,   -11,
    -517,  -517,   -11,   -11,   -11,   158,   489,   478,  -517,  -517,
    -517,   160,  -517,   319,  -517,   444,   -11,   447,   455,   456,
     536,   -11,   302,   501,   489,  -517,  -517,  -517,  -517,   161,
     -11,  -517,  -517,  -517,  -517,  -517,   -43,   453,   453,   453,
     453,   453,  -517,   302,  -517,  -517,  -517,  -517,  -517,   -11,
     502,   501,  -517,  -517,  -517,   457,    -7,  -517,     6,   -11,
      62,    92,   -11,  -517,   -11,   299,  -517,   502,  -517,  -517,
     -11,  -517,  -517,   -11,   453,  -517,  -517,   453,  -517,   453,
    -517,  -517,   -11,  -517,   471,   472,  -517,  -517,   -11,  -517,
     -11,   -11,   -11,  -517,   -11,   -11,  -517,  -517,  -517,  -517,
    -517,  -517
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -517,  -517,  -517,  -517,  -517,  -517,  -517,   543,  -517,   483,
    -517,  -517,  -517,   442,  -517,   382,  -517,  -517,  -517,   323,
     -76,  -517,  -517,  -517,   228,  -517,   191,  -517,   166,  -517,
    -517,  -517,   288,  -206,  -203,  -517,  -517,  -517,  -517,  -517,
     440,  -517,  -517,  -192,  -517,   -19,  -517,   229,  -517,  -517,
    -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,
    -517,  -517,  -517,  -517,  -517,  -517,  -517,   307,  -149,  -517,
    -517,   211,  -517,  -517,  -386,  -517,  -517,  -517,  -517,  -517,
    -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,  -517,   -13,
     -83,  -517,  -243,  -517,  -517,   141,  -517,  -517,   -22,  -517,
    -517,  -517,  -517,  -517,  -517,    94,  -517,  -517,  -517,     0,
    -517,  -517,   -25,  -517,  -517,   -44,  -517,  -517,    54,  -517,
    -517,    23,  -517,  -516,  -405,  -517,  -263,  -241,   -74,   -17,
     335,   298,  -517,  -517,  -517,   350,    12,  -154,  -276,   -51,
    -517,   448,  -517,    -1,    26,  -517,  -453,   -52,  -517,  -517,
    -517,  -517,  -517,  -106,  -517,   529,  -195,  -517,   423,  -517,
    -517,  -517,  -189,  -517,  -517,  -517,  -517,   495
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -189
static const yytype_int16 yytable[] =
{
       8,   215,   310,   128,   126,   178,   258,   217,   122,    70,
     296,   120,    75,    76,    77,    78,    79,    80,    81,    86,
     155,   340,   155,   122,   163,   122,   311,     1,   288,   164,
     454,   289,   528,   106,   165,     7,   143,   166,   167,   147,
       7,   437,   290,   332,    82,   292,   168,   479,   480,     7,
       7,   169,     7,   191,   325,   616,   170,   372,   492,   364,
     365,    10,    87,   134,   135,    71,   379,     7,    83,   142,
     113,     7,   455,   456,   457,   559,   125,   125,   485,   359,
     288,    86,    86,   289,     7,   127,   146,   121,   371,   148,
     107,   632,   297,   143,   290,   524,   525,   292,   327,     7,
     395,   216,   405,   353,   634,   537,   176,   481,   482,   644,
     225,     7,    87,   179,   243,   244,   245,   196,   197,   198,
     199,   200,   458,   459,   333,   414,   125,   483,   654,   131,
     132,   246,   247,   248,   249,    86,    86,    86,    86,    86,
       7,   481,   482,   146,   618,   619,   620,   621,   622,   243,
     244,   245,   209,   213,   576,   481,   482,   577,   578,   579,
     637,   214,   224,     7,   217,   523,   246,   247,   248,   249,
       7,   591,     9,   228,   573,   500,    10,    32,    99,   210,
     238,   650,   112,   250,   651,     7,   652,     7,   241,   214,
     639,   617,   258,   188,   312,   189,   136,   137,   138,   394,
      87,   259,   539,   139,   140,   261,   105,   328,    88,    89,
      88,    89,    32,   635,   636,   638,   640,   641,   413,   642,
     195,     7,   481,   482,   481,   482,     7,   374,   649,   398,
     399,   282,   283,   111,    87,   203,   560,   653,   214,   214,
     446,   142,   538,   656,   570,   657,   658,   659,   561,   660,
     661,   417,   587,   614,    64,   389,   130,    65,   114,   307,
      66,   308,   309,    71,   213,   122,   213,   125,   136,   150,
     138,   136,   137,   138,   136,   139,   140,   319,   139,   140,
     326,   139,   140,   329,   418,   419,   420,   155,   462,   141,
     139,   140,   334,   463,   107,   339,   282,   396,   175,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   464,   433,   517,   518,   519,   465,   219,   220,   213,
      95,    96,    97,    98,   181,   100,   101,   102,   103,   104,
     163,   190,   282,   189,   373,   164,   434,   233,   293,   326,
     165,   470,   114,   166,   167,   364,   365,   476,   477,   478,
     441,   442,   168,   598,   599,   600,   601,   169,   529,   530,
     531,   269,   170,   270,   277,   187,   278,   647,   490,   127,
     521,   326,   522,   397,   536,   193,   189,   282,   398,   399,
     194,    65,   643,   205,   207,   572,   208,   213,   574,   218,
     149,   458,   459,   151,   152,   153,   154,   214,   158,   159,
     160,   161,   162,   227,   326,   447,   448,   449,   466,   467,
     468,   469,   471,   472,   473,   474,   475,   588,   185,   572,
     186,   221,   222,   223,   230,   231,   233,   232,   267,   189,
     305,   320,   240,   242,   264,   588,   484,   266,   322,   268,
     335,   125,   348,   374,   437,   349,   350,   351,   352,    13,
     354,    14,    15,    16,    17,   355,   356,    18,    19,    20,
     357,    21,    22,    23,    24,    25,   358,    26,   360,   361,
     362,   378,   363,   505,   388,   380,   107,    27,    28,    29,
      30,    31,   381,   527,   540,   540,   540,   540,   382,   540,
     540,   540,   540,   383,   540,   540,   384,   540,   540,   540,
     385,   513,   520,   260,   386,   262,   263,   415,   265,  -188,
     440,   493,   494,   495,   496,   497,   271,   498,   272,   273,
     274,   275,   276,   499,    32,    33,   510,    34,   279,   563,
     564,    35,    64,   485,   481,   558,   565,   581,   590,   595,
     592,   298,   299,   300,   301,   302,   303,   304,   593,   594,
     609,   630,   625,    65,    72,   643,   115,   575,   527,   294,
     184,   527,   527,   527,   239,   377,   400,   445,   192,   314,
     315,   316,   317,   318,   330,   527,   313,   387,   393,   486,
     597,   623,   535,   646,   613,   589,   629,   569,   109,   615,
     586,   580,   204,   655,   226,   527,   341,   342,   343,   344,
     345,   346,   347,   177,     0,     0,     0,     0,   624,     0,
       0,     0,     0,     0,     0,   633,     0,   527,   527,   527,
     527,   527,     0,   527,     0,     0,     0,     0,     0,   213,
       0,     0,   527,     0,     0,     0,     0,     0,     0,     0,
       0,   527,     0,     0,     0,     0,     0,   527,     0,   527,
     527,   527,     0,   527,   527,     0,     0,     0,     0,     0,
       0,     0,   390,   391,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   406,   407,
     408,   409,   410,   411,   412,     0,     0,     0,   416,     0,
       0,     0,     0,     0,     0,     0,   443,   444,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   450,   451,   452,
     453,     0,     0,     0,     0,    13,     0,    14,    15,    16,
      17,     0,     0,    18,    19,    20,     0,    21,    22,    23,
      24,    25,     0,    26,     0,     0,     0,     0,     0,     0,
       0,   491,   107,    27,    28,    29,    30,    31,    13,     0,
      14,    15,    16,    17,     0,     0,    18,    19,    20,     0,
      21,    22,    23,    24,    25,     0,    26,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    27,    28,    29,    30,
      31,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    33,   284,    34,     0,     0,     0,   285,     0,     0,
       0,     0,     0,    13,     0,    14,    15,    16,    17,     0,
       0,    18,    19,    20,     0,    21,    22,    23,    24,    25,
       0,    26,     0,    32,    33,     0,    34,     0,     0,     0,
      35,    27,    28,    29,    30,    31,   541,   541,   541,   541,
       0,   541,   541,   541,   541,     0,   541,   541,     0,   541,
     541,   541,   546,   547,   548,     0,   549,   550,   551,   552,
       0,   553,   554,     0,   555,   556,   557,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    33,
     284,    34,     0,     0,     0,   285
};

static const yytype_int16 yycheck[] =
{
       1,   155,   265,    79,    78,   111,   201,   156,    18,    10,
       9,    17,    13,    14,    15,    16,    17,    18,    19,    20,
      11,   297,    11,    18,     6,    18,   267,    84,   234,    11,
     416,   234,   485,    34,    16,    78,    87,    19,    20,    90,
      78,    10,   234,   286,    72,   234,    28,   433,   434,    78,
      78,    33,    78,   127,    92,    98,    38,   333,   444,     7,
       8,     6,    91,    82,    83,    10,    92,    78,    96,    98,
      71,    78,    30,    31,    32,   528,    77,    78,    47,   320,
     286,    82,    83,   286,    78,    95,    87,    93,   331,    90,
      38,    98,    91,   144,   286,   481,   482,   286,    93,    78,
      93,    92,   378,    92,    98,   491,   107,    73,    74,   625,
      92,    78,    91,   114,    23,    24,    25,   136,   137,   138,
     139,   140,    80,    81,    91,   388,   127,    93,   644,    76,
      77,    40,    41,    42,    43,   136,   137,   138,   139,   140,
      78,    73,    74,   144,   597,   598,   599,   600,   601,    23,
      24,    25,   153,   154,   559,    73,    74,   562,   563,   564,
      98,    78,   163,    78,   313,    97,    40,    41,    42,    43,
      78,   576,     0,   174,    91,    93,     6,    86,    91,    94,
     181,   634,    93,    92,   637,    78,   639,    78,   189,    78,
      98,   596,   387,    93,   268,    95,    73,    74,    75,    92,
      91,   202,    91,    80,    81,   206,    91,   283,    99,   100,
      99,   100,    86,   618,   619,   620,   621,   622,    92,   624,
      97,    78,    73,    74,    73,    74,    78,    34,   633,    36,
      37,   232,   233,    91,    91,    92,    78,   642,    78,    78,
      92,    98,    93,   648,    93,   650,   651,   652,    90,   654,
     655,    11,    92,    92,    79,   361,    93,    82,     5,   260,
      85,   262,   263,    10,   265,    18,   267,   268,    73,    98,
      75,    73,    74,    75,    73,    80,    81,   278,    80,    81,
     281,    80,    81,   284,    44,    45,    46,    11,    11,    91,
      80,    81,   293,    16,    38,   296,   297,   373,    93,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    11,    72,    69,    70,    71,    16,    93,    94,   320,
      22,    23,    24,    25,     6,    27,    28,    29,    30,    31,
       6,    93,   333,    95,   335,    11,    96,    28,    29,   340,
      16,   424,     5,    19,    20,     7,     8,   430,   431,   432,
      93,    94,    28,    51,    52,    53,    54,    33,    55,    56,
      57,    91,    38,    93,    93,    93,    95,   630,   442,    95,
      69,   372,    71,   374,    93,    93,    95,   378,    36,    37,
      93,    82,    83,    94,    94,   539,    94,   388,   542,    94,
      92,    80,    81,    95,    96,    97,    98,    78,   100,   101,
     102,   103,   104,    93,   405,   406,   407,   408,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   571,   120,   573,
     122,    94,    94,    94,    12,    92,    28,    91,    98,    95,
      22,    34,    93,    93,    93,   589,   437,    93,    22,    94,
      33,   442,    91,    34,    10,    93,    93,    93,    93,    11,
      93,    13,    14,    15,    16,    93,    93,    19,    20,    21,
      93,    23,    24,    25,    26,    27,    93,    29,    93,    91,
      93,    91,    93,    60,    35,    94,    38,    39,    40,    41,
      42,    43,    94,   484,   501,   502,   503,   504,    94,   506,
     507,   508,   509,    94,   511,   512,    94,   514,   515,   516,
      94,    66,    71,   205,    94,   207,   208,    92,   210,    63,
      93,    93,    93,    93,    93,    93,   218,    93,   220,   221,
     222,   223,   224,    93,    86,    87,    63,    89,   230,   530,
     531,    93,    79,    47,    73,    94,    58,    48,    94,     3,
      93,   243,   244,   245,   246,   247,   248,   249,    93,    93,
      49,    94,    50,    82,    11,    83,    73,   558,   559,   236,
     118,   562,   563,   564,   182,   337,   375,   401,   128,   271,
     272,   273,   274,   275,   286,   576,   269,   348,   367,   438,
     581,   603,   488,   627,   584,   573,   611,   533,    59,   590,
     567,   565,   144,   645,   171,   596,   298,   299,   300,   301,
     302,   303,   304,   108,    -1,    -1,    -1,    -1,   609,    -1,
      -1,    -1,    -1,    -1,    -1,   616,    -1,   618,   619,   620,
     621,   622,    -1,   624,    -1,    -1,    -1,    -1,    -1,   630,
      -1,    -1,   633,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   642,    -1,    -1,    -1,    -1,    -1,   648,    -1,   650,
     651,   652,    -1,   654,   655,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,    -1,    -1,    -1,   390,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   398,   399,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   409,   410,   411,
     412,    -1,    -1,    -1,    -1,    11,    -1,    13,    14,    15,
      16,    -1,    -1,    19,    20,    21,    -1,    23,    24,    25,
      26,    27,    -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   443,    38,    39,    40,    41,    42,    43,    11,    -1,
      13,    14,    15,    16,    -1,    -1,    19,    20,    21,    -1,
      23,    24,    25,    26,    27,    -1,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    88,    89,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    -1,    11,    -1,    13,    14,    15,    16,    -1,
      -1,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
      -1,    29,    -1,    86,    87,    -1,    89,    -1,    -1,    -1,
      93,    39,    40,    41,    42,    43,   501,   502,   503,   504,
      -1,   506,   507,   508,   509,    -1,   511,   512,    -1,   514,
     515,   516,   502,   503,   504,    -1,   506,   507,   508,   509,
      -1,   511,   512,    -1,   514,   515,   516,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    -1,    -1,    -1,    93
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    84,   102,   103,   104,   251,   252,    78,   244,     0,
       6,   107,   108,    11,    13,    14,    15,    16,    19,    20,
      21,    23,    24,    25,    26,    27,    29,    39,    40,    41,
      42,    43,    86,    87,    89,    93,   134,   135,   136,   137,
     138,   139,   140,   142,   144,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   250,   254,   255,
     256,   257,   263,   266,    79,    82,    85,   224,   247,   253,
     244,    10,   108,   109,   110,   244,   244,   244,   244,   244,
     244,   244,    72,    96,   146,   147,   244,    91,    99,   100,
     230,   231,   232,   240,   244,   232,   232,   232,   232,    91,
     232,   232,   232,   232,   232,    91,   244,    38,   193,   256,
     268,    91,    93,   244,     5,   110,   111,   112,   113,   114,
      17,    93,    18,   121,   229,   244,   229,    95,   121,   141,
      93,    76,    77,   143,   146,   146,    73,    74,    75,    80,
      81,    91,    98,   240,   241,   242,   244,   240,   244,   232,
      98,   232,   232,   232,   232,    11,   168,   169,   232,   232,
     232,   232,   232,     6,    11,    16,    19,    20,    28,    33,
      38,   258,   259,   260,   261,    93,   244,   268,   254,   244,
     105,     6,   115,   116,   114,   232,   232,    93,    93,    95,
      93,   229,   141,    93,    93,    97,   146,   146,   146,   146,
     146,   148,   243,    92,   242,    94,   233,    94,    94,   244,
      94,   227,   228,   244,    78,   238,    92,   169,    94,    93,
      94,    94,    94,    94,   244,    92,   259,    93,   244,   262,
      12,    92,    91,    28,   117,   118,   119,   120,   244,   116,
      93,   244,    93,    23,    24,    25,    40,    41,    42,    43,
      92,   149,   150,   151,   152,   153,   154,   155,   257,   244,
     232,   244,   232,   232,    93,   232,    93,    98,    94,    91,
      93,   232,   232,   232,   232,   232,   232,    93,    95,   232,
     264,   239,   244,   244,    88,    93,   132,   133,   134,   135,
     144,   249,   263,    29,   120,   122,     9,    91,   232,   232,
     232,   232,   232,   232,   232,    22,   145,   244,   244,   244,
     227,   228,   229,   168,   232,   232,   232,   232,   232,   244,
      34,   194,    22,   265,   267,    92,   244,    93,   121,   244,
     133,   192,   193,    91,   244,    33,   123,   124,   125,   244,
     239,   232,   232,   232,   232,   232,   232,   232,    91,    93,
      93,    93,    93,    92,    93,    93,    93,    93,    93,   228,
      93,    91,    93,    93,     7,     8,   170,   171,   172,   173,
     174,   193,   239,   244,    34,   126,   127,   125,    91,    92,
      94,    94,    94,    94,    94,    94,    94,   148,    35,   254,
     232,   232,   106,   172,    92,    93,   121,   244,    36,    37,
     127,   128,   129,   130,   131,   239,   232,   232,   232,   232,
     232,   232,   232,    92,   227,    92,   232,    11,    44,    45,
      46,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    72,    96,   175,   176,    10,   195,   196,
      93,    93,    94,   232,   232,   129,    92,   244,   244,   244,
     232,   232,   232,   232,   175,    30,    31,    32,    80,    81,
     190,   191,    11,    16,    11,    16,   190,   190,   190,   190,
     191,   190,   190,   190,   190,   190,   191,   191,   191,   175,
     175,    73,    74,    93,   244,    47,   196,   204,   205,   206,
     229,   232,   175,    93,    93,    93,    93,    93,    93,    93,
      93,   186,   188,   187,   189,    60,   177,   178,   179,   180,
      63,   181,   182,    66,   183,   184,   185,    69,    70,    71,
      71,    69,    71,    97,   175,   175,   225,   244,   247,    55,
      56,    57,   217,   218,   219,   206,    93,   175,    93,    91,
     230,   231,   234,   235,   236,   238,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   236,   236,    94,   247,
      78,    90,   245,   244,   244,    58,   220,   221,   222,   219,
      93,   237,   238,    91,   238,   244,   225,   225,   225,   225,
     245,    48,   207,   208,   209,   210,   222,    92,   238,   237,
      94,   225,    93,    93,    93,     3,   246,   244,    51,    52,
      53,    54,   197,   198,   199,   200,   201,   202,   203,    49,
     211,   212,   213,   210,    92,   244,    98,   225,   247,   247,
     247,   247,   247,   199,   244,    50,   214,   215,   216,   213,
      94,   226,    98,   244,    98,   225,   225,    98,   225,    98,
     225,   225,   225,    83,   224,   248,   216,   227,   223,   225,
     247,   247,   247,   225,   224,   248,   225,   225,   225,   225,
     225,   225
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:

/* Line 1464 of yacc.c  */
#line 152 "policy_parse.y"
    { if (define_policy(pass, 0) == -1) return -1; }
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 154 "policy_parse.y"
    { if (pass == 1) { if (policydb_index_classes(policydbp)) return -1; }
                            else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1; }}
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 157 "policy_parse.y"
    { if (pass == 1) { if (policydb_index_bools(policydbp)) return -1;}
			   else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1;}}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 165 "policy_parse.y"
    {if (define_class()) return -1;}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 171 "policy_parse.y"
    {if (define_initial_sid()) return -1;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 182 "policy_parse.y"
    {if (define_common_perms()) return -1;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 188 "policy_parse.y"
    {if (define_av_perms(FALSE)) return -1;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 190 "policy_parse.y"
    {if (define_av_perms(TRUE)) return -1;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 192 "policy_parse.y"
    {if (define_av_perms(TRUE)) return -1;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 203 "policy_parse.y"
    {if (define_sens()) return -1;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 205 "policy_parse.y"
    {if (define_sens()) return -1;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 210 "policy_parse.y"
    {if (define_dominance()) return -1;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 212 "policy_parse.y"
    {if (define_dominance()) return -1;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 221 "policy_parse.y"
    {if (define_category()) return -1;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 223 "policy_parse.y"
    {if (define_category()) return -1;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 229 "policy_parse.y"
    {if (define_level()) return -1;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 231 "policy_parse.y"
    {if (define_level()) return -1;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 240 "policy_parse.y"
    { if (define_constraint((constraint_expr_t*)(yyvsp[(4) - (5)].valptr))) return -1; }
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 243 "policy_parse.y"
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[(3) - (4)].valptr))) return -1; }
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 272 "policy_parse.y"
    { if (define_attrib()) return -1;}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 275 "policy_parse.y"
    {if (define_type(1)) return -1;}
    break;

  case 75:

/* Line 1464 of yacc.c  */
#line 277 "policy_parse.y"
    {if (define_type(0)) return -1;}
    break;

  case 76:

/* Line 1464 of yacc.c  */
#line 280 "policy_parse.y"
    {if (define_typealias()) return -1;}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 283 "policy_parse.y"
    {if (define_typeattribute()) return -1;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 286 "policy_parse.y"
    {if (define_typebounds()) return -1;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 292 "policy_parse.y"
    {if (define_bool()) return -1;}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 295 "policy_parse.y"
    { if (insert_id("T",0)) return -1; }
    break;

  case 83:

/* Line 1464 of yacc.c  */
#line 297 "policy_parse.y"
    { if (insert_id("F",0)) return -1; }
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 300 "policy_parse.y"
    { if (pass == 2) { if (define_conditional((cond_expr_t*)(yyvsp[(2) - (6)].ptr), (avrule_t*)(yyvsp[(4) - (6)].ptr), (avrule_t*)(yyvsp[(6) - (6)].ptr)) < 0) return -1;  }}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 303 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(3) - (4)].ptr); }
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 305 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 307 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(2) - (3)].ptr);}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 309 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_NOT, (yyvsp[(2) - (2)].ptr), 0);
			  if ((yyval.ptr) == 0) return -1; }
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 312 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_AND, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 315 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_OR, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return   -1; }
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 318 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_XOR, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 321 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_EQ, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 324 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_NEQ, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 327 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 330 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_BOOL,0, 0);
			  if ((yyval.ptr) == COND_ERR) return   -1; }
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 334 "policy_parse.y"
    { (yyval.ptr) = define_cond_pol_list((avrule_t *)(yyvsp[(1) - (2)].ptr), (avrule_t *)(yyvsp[(2) - (2)].ptr)); }
    break;

  case 97:

/* Line 1464 of yacc.c  */
#line 336 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 339 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 341 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 343 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 346 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_TRANSITION) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 349 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_MEMBER) ;
                          if ((yyval.ptr) ==  COND_ERR) return -1;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 352 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_CHANGE) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 356 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 358 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 360 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 362 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 365 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_ALLOWED) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 369 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITALLOW) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 373 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITDENY) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 377 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_DONTAUDIT);
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 381 "policy_parse.y"
    {if (define_compute_type(AVRULE_TRANSITION)) return -1;}
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 383 "policy_parse.y"
    {if (define_compute_type(AVRULE_MEMBER)) return -1;}
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 385 "policy_parse.y"
    {if (define_compute_type(AVRULE_CHANGE)) return -1;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 388 "policy_parse.y"
    { if (define_range_trans(0)) return -1; }
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 390 "policy_parse.y"
    { if (define_range_trans(1)) return -1; }
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 399 "policy_parse.y"
    {if (define_te_avtab(AVRULE_ALLOWED)) return -1; }
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 402 "policy_parse.y"
    {if (define_te_avtab(AVRULE_AUDITALLOW)) return -1; }
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 405 "policy_parse.y"
    {if (define_te_avtab(AVRULE_AUDITDENY)) return -1; }
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 408 "policy_parse.y"
    {if (define_te_avtab(AVRULE_DONTAUDIT)) return -1; }
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 411 "policy_parse.y"
    {if (define_te_avtab(AVRULE_NEVERALLOW)) return -1; }
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 414 "policy_parse.y"
    {if (define_role_types()) return -1;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 416 "policy_parse.y"
    {if (define_role_types()) return -1;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 421 "policy_parse.y"
    {if (define_role_trans()) return -1; }
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 424 "policy_parse.y"
    {if (define_role_allow()) return -1; }
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 427 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 429 "policy_parse.y"
    { (yyval.ptr) = merge_roles_dom((role_datum_t*)(yyvsp[(1) - (2)].ptr), (role_datum_t*)(yyvsp[(2) - (2)].ptr)); if ((yyval.ptr) == 0) return -1;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 432 "policy_parse.y"
    {(yyval.ptr) = define_role_dom(NULL); if ((yyval.ptr) == 0) return -1;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 434 "policy_parse.y"
    {(yyval.ptr) = define_role_dom((role_datum_t*)(yyvsp[(4) - (5)].ptr)); if ((yyval.ptr) == 0) return -1;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 446 "policy_parse.y"
    { if (define_constraint((constraint_expr_t*)(yyvsp[(4) - (5)].valptr))) return -1; }
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 449 "policy_parse.y"
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[(3) - (4)].valptr))) return -1; }
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 452 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(2) - (3)].valptr); }
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 454 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NOT, (yyvsp[(2) - (2)].valptr), 0);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 457 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_AND, (yyvsp[(1) - (3)].valptr), (yyvsp[(3) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 460 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_OR, (yyvsp[(1) - (3)].valptr), (yyvsp[(3) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 463 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(1) - (1)].valptr); }
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 466 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 469 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 472 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_TYPE, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 474 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 475 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_USER, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 477 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 478 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 480 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 481 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 483 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 484 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 486 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 487 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 489 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 490 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 492 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 493 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 495 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 496 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 498 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 499 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 502 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 504 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 505 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 507 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 508 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 511 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[(2) - (2)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 513 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 514 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 516 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 517 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 520 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1L2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 523 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 526 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1L2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 183:

/* Line 1464 of yacc.c  */
#line 529 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 532 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H1, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 535 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L2H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 539 "policy_parse.y"
    { (yyval.valptr) = CEXPR_EQ; }
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 541 "policy_parse.y"
    { (yyval.valptr) = CEXPR_NEQ; }
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 544 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(1) - (1)].valptr); }
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 546 "policy_parse.y"
    { (yyval.valptr) = CEXPR_DOM; }
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 548 "policy_parse.y"
    { (yyval.valptr) = CEXPR_DOMBY; }
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 550 "policy_parse.y"
    { (yyval.valptr) = CEXPR_INCOMP; }
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 556 "policy_parse.y"
    {if (define_user()) return -1;}
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 565 "policy_parse.y"
    {if (define_initial_sid_context()) return -1;}
    break;

  case 208:

/* Line 1464 of yacc.c  */
#line 578 "policy_parse.y"
    {if (define_pirq_context((yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 209:

/* Line 1464 of yacc.c  */
#line 581 "policy_parse.y"
    {if (define_iomem_context((yyvsp[(2) - (3)].val),(yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 210:

/* Line 1464 of yacc.c  */
#line 583 "policy_parse.y"
    {if (define_iomem_context((yyvsp[(2) - (5)].val),(yyvsp[(4) - (5)].val))) return -1;}
    break;

  case 211:

/* Line 1464 of yacc.c  */
#line 586 "policy_parse.y"
    {if (define_ioport_context((yyvsp[(2) - (3)].val),(yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 212:

/* Line 1464 of yacc.c  */
#line 588 "policy_parse.y"
    {if (define_ioport_context((yyvsp[(2) - (5)].val),(yyvsp[(4) - (5)].val))) return -1;}
    break;

  case 213:

/* Line 1464 of yacc.c  */
#line 591 "policy_parse.y"
    {if (define_pcidevice_context((yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 218:

/* Line 1464 of yacc.c  */
#line 600 "policy_parse.y"
    {if (define_fs_context((yyvsp[(2) - (5)].val),(yyvsp[(3) - (5)].val))) return -1;}
    break;

  case 224:

/* Line 1464 of yacc.c  */
#line 611 "policy_parse.y"
    {if (define_port_context((yyvsp[(3) - (4)].val),(yyvsp[(3) - (4)].val))) return -1;}
    break;

  case 225:

/* Line 1464 of yacc.c  */
#line 613 "policy_parse.y"
    {if (define_port_context((yyvsp[(3) - (6)].val),(yyvsp[(5) - (6)].val))) return -1;}
    break;

  case 230:

/* Line 1464 of yacc.c  */
#line 622 "policy_parse.y"
    {if (define_netif_context()) return -1;}
    break;

  case 235:

/* Line 1464 of yacc.c  */
#line 631 "policy_parse.y"
    {if (define_ipv4_node_context()) return -1;}
    break;

  case 236:

/* Line 1464 of yacc.c  */
#line 633 "policy_parse.y"
    {if (define_ipv6_node_context()) return -1;}
    break;

  case 241:

/* Line 1464 of yacc.c  */
#line 642 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_XATTR)) return -1;}
    break;

  case 242:

/* Line 1464 of yacc.c  */
#line 644 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_TASK)) return -1;}
    break;

  case 243:

/* Line 1464 of yacc.c  */
#line 646 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_TRANS)) return -1;}
    break;

  case 248:

/* Line 1464 of yacc.c  */
#line 655 "policy_parse.y"
    {if (define_genfs_context(1)) return -1;}
    break;

  case 249:

/* Line 1464 of yacc.c  */
#line 656 "policy_parse.y"
    {insert_id("-", 0);}
    break;

  case 250:

/* Line 1464 of yacc.c  */
#line 657 "policy_parse.y"
    {if (define_genfs_context(1)) return -1;}
    break;

  case 251:

/* Line 1464 of yacc.c  */
#line 659 "policy_parse.y"
    {if (define_genfs_context(0)) return -1;}
    break;

  case 252:

/* Line 1464 of yacc.c  */
#line 662 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 256:

/* Line 1464 of yacc.c  */
#line 670 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 257:

/* Line 1464 of yacc.c  */
#line 672 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 258:

/* Line 1464 of yacc.c  */
#line 675 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 259:

/* Line 1464 of yacc.c  */
#line 677 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 264:

/* Line 1464 of yacc.c  */
#line 687 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 265:

/* Line 1464 of yacc.c  */
#line 689 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 266:

/* Line 1464 of yacc.c  */
#line 691 "policy_parse.y"
    { if (insert_id("*", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
    break;

  case 267:

/* Line 1464 of yacc.c  */
#line 694 "policy_parse.y"
    { if (insert_id("~", 0)) return -1;
			  if (insert_separator(0)) return -1; }
    break;

  case 268:

/* Line 1464 of yacc.c  */
#line 697 "policy_parse.y"
    { if (insert_id("~", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
    break;

  case 269:

/* Line 1464 of yacc.c  */
#line 699 "policy_parse.y"
    { if (insert_id("-", 0)) return -1; }
    break;

  case 270:

/* Line 1464 of yacc.c  */
#line 700 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 271:

/* Line 1464 of yacc.c  */
#line 703 "policy_parse.y"
    { if (insert_id("~", 1)) return -1; }
    break;

  case 272:

/* Line 1464 of yacc.c  */
#line 706 "policy_parse.y"
    { if (insert_id("*", 1)) return -1; }
    break;

  case 280:

/* Line 1464 of yacc.c  */
#line 718 "policy_parse.y"
    { if (insert_id(yytext, 1)) return -1; }
    break;

  case 287:

/* Line 1464 of yacc.c  */
#line 727 "policy_parse.y"
    { if (insert_id("-", 0)) return -1; }
    break;

  case 290:

/* Line 1464 of yacc.c  */
#line 730 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 291:

/* Line 1464 of yacc.c  */
#line 733 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 292:

/* Line 1464 of yacc.c  */
#line 735 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 293:

/* Line 1464 of yacc.c  */
#line 738 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 294:

/* Line 1464 of yacc.c  */
#line 741 "policy_parse.y"
    { (yyval.val) = strtoul(yytext,NULL,0); }
    break;

  case 295:

/* Line 1464 of yacc.c  */
#line 744 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 296:

/* Line 1464 of yacc.c  */
#line 747 "policy_parse.y"
    {if (define_polcap()) return -1;}
    break;

  case 297:

/* Line 1464 of yacc.c  */
#line 750 "policy_parse.y"
    {if (define_permissive()) return -1;}
    break;

  case 298:

/* Line 1464 of yacc.c  */
#line 755 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1;
                          if (policydb_index_others(NULL, policydbp, 0)) return -1;
                        }
    break;

  case 299:

/* Line 1464 of yacc.c  */
#line 760 "policy_parse.y"
    { if (define_policy(pass, 1) == -1) return -1; }
    break;

  case 300:

/* Line 1464 of yacc.c  */
#line 763 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 301:

/* Line 1464 of yacc.c  */
#line 765 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 317:

/* Line 1464 of yacc.c  */
#line 789 "policy_parse.y"
    { if (require_class(pass)) return -1; }
    break;

  case 318:

/* Line 1464 of yacc.c  */
#line 791 "policy_parse.y"
    { (yyval.require_func) = require_role; }
    break;

  case 319:

/* Line 1464 of yacc.c  */
#line 792 "policy_parse.y"
    { (yyval.require_func) = require_type; }
    break;

  case 320:

/* Line 1464 of yacc.c  */
#line 793 "policy_parse.y"
    { (yyval.require_func) = require_attribute; }
    break;

  case 321:

/* Line 1464 of yacc.c  */
#line 794 "policy_parse.y"
    { (yyval.require_func) = require_user; }
    break;

  case 322:

/* Line 1464 of yacc.c  */
#line 795 "policy_parse.y"
    { (yyval.require_func) = require_bool; }
    break;

  case 323:

/* Line 1464 of yacc.c  */
#line 796 "policy_parse.y"
    { (yyval.require_func) = require_sens; }
    break;

  case 324:

/* Line 1464 of yacc.c  */
#line 797 "policy_parse.y"
    { (yyval.require_func) = require_cat; }
    break;

  case 325:

/* Line 1464 of yacc.c  */
#line 800 "policy_parse.y"
    { if ((yyvsp[(0) - (1)].require_func) (pass)) return -1; }
    break;

  case 326:

/* Line 1464 of yacc.c  */
#line 802 "policy_parse.y"
    { if ((yyvsp[(0) - (3)].require_func) (pass)) return -1; }
    break;

  case 327:

/* Line 1464 of yacc.c  */
#line 805 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1; }
    break;

  case 328:

/* Line 1464 of yacc.c  */
#line 807 "policy_parse.y"
    { if (end_optional(pass) == -1) return -1; }
    break;

  case 329:

/* Line 1464 of yacc.c  */
#line 810 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1; }
    break;

  case 331:

/* Line 1464 of yacc.c  */
#line 814 "policy_parse.y"
    { if (begin_optional(pass) == -1) return -1; }
    break;

  case 332:

/* Line 1464 of yacc.c  */
#line 817 "policy_parse.y"
    { if (begin_optional_else(pass) == -1) return -1; }
    break;



/* Line 1464 of yacc.c  */
#line 3615 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



